;;;; macosx-errors.scm
;;;; Kon Lovett, Mar '09
;;;; Kon Lovett, Feb '18

;;;

(module macosx-errors

(;export
  exception-osstatus
  exception-oserr
  ;
  osstatus-condition?
  oserr-condition?)

(import scheme chicken)
(use condition-utils)

;;

(define (make-exn-osstatus-condition loc msg cod . args)
  (make-exn-condition+ loc msg args `(osstatus code ,cod)) )

(define (make-exn-oserr-condition loc msg cod . args)
  (make-exn-condition+ loc msg args `(oserr code ,cod)) )

;;

(define (exception-osstatus loc msg code . args)
  (abort (apply make-exn-osstatus-condition loc msg code args)) )

(define (exception-oserr loc msg code . args)
  (abort (apply make-exn-oserr-condition loc msg code args)) )

(: osstatus-condition? (* -> boolean : condition))
;
(define osstatus-condition?
  (make-condition-predicate osstatus) )

(: oserr-condition? (* -> boolean : condition))
;
(define oserr-condition?
  (make-condition-predicate oserr) )

) ;module macosx-errors
